/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * CaConstants.java,v 1.1.1.1 2003/09/11 14:42:49 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */


package gov.aps.epics.jca;


public interface CaConstants {

  static final public int THREAD_CTRL_FIRST   = 0;
  static final public int THREAD_CTRL_INTERNAL= 0;
  static final public int THREAD_CTRL_EXTERNAL= 1;
  static final public int THREAD_CTRL_LAST    = 1;

  static final public String[] THREAD_CTRL_STRING= {
    "THREAD_CTRL_INTERNAL",
    "THREAD_CTRL_EXTERNAL"
  };


  static final public int CALLBACK_MODE_FIRST        = 0;
  static final public int DISABLE_PREEMPTIVE_CALLBACK= 0;
  static final public int ENABLE_PREEMPTIVE_CALLBACK = 1;
  static final public int CALLBACK_MODE_LAST         = 1;

  static final public String[] CALLBACK_MODE_STRING= { 
    "DISABLE_PREEMPTIVE_CALLBACK", 
    "ENABLE_PREEMPTIVE_CALLBACK"};


  static final public int DBE_VALUE= 1;
  static final public int DBE_LOG= 2;
  static final public int DBE_ALARM= 4;



  static final public int DBR_FIRST      = 0;
  static final public int DBR_STRING     = 0;
  static final public int DBR_SHORT      = 1;
  static final public int DBR_FLOAT      = 2;
  static final public int DBR_ENUM       = 3;
  static final public int DBR_BYTE       = 4;
  static final public int DBR_INT        = 5;
  static final public int DBR_DOUBLE     = 6;
  static final public int DBR_STS_STRING = 7;
  static final public int DBR_STS_SHORT  = 8;
  static final public int DBR_STS_FLOAT  = 9;
  static final public int DBR_STS_ENUM   = 10;
  static final public int DBR_STS_BYTE   = 11;
  static final public int DBR_STS_INT    = 12;
  static final public int DBR_STS_DOUBLE = 13;
  static final public int DBR_TIME_STRING= 14;
  static final public int DBR_TIME_SHORT = 15;
  static final public int DBR_TIME_FLOAT = 16;
  static final public int DBR_TIME_ENUM  = 17;
  static final public int DBR_TIME_BYTE  = 18;
  static final public int DBR_TIME_INT   = 19;
  static final public int DBR_TIME_DOUBLE= 20;
  static final public int DBR_GR_STRING  = 21;
  static final public int DBR_GR_SHORT   = 22;
  static final public int DBR_GR_FLOAT   = 23;
  static final public int DBR_LABELS_ENUM= 24;
  static final public int DBR_GR_BYTE    = 25;
  static final public int DBR_GR_INT     = 26;
  static final public int DBR_GR_DOUBLE  = 27;
  static final public int DBR_CTRL_STRING= 28;
  static final public int DBR_CTRL_SHORT = 29;
  static final public int DBR_CTRL_FLOAT = 30;
  static final public int DBR_CTRL_ENUM  = 31;
  static final public int DBR_CTRL_BYTE  = 32;
  static final public int DBR_CTRL_INT   = 33;
  static final public int DBR_CTRL_DOUBLE= 34;
  static final public int DBR_PUT_ACKT   = 35;
  static final public int DBR_PUT_ACKS   = 36;
  static final public int DBR_STSACK_STRING= 37;

  static final public int DBR_LAST       = 37;


  static final public String[] DBR_TYPE_STRING= {
    "DBR_STRING",
    "DBR_SHORT",
    "DBR_FLOAT",
    "DBR_ENUM",       
    "DBR_BYTE",       
    "DBR_INT",        
    "DBR_DOUBLE",     
    "DBR_STS_STRING", 
    "DBR_STS_SHORT",  
    "DBR_STS_FLOAT",  
    "DBR_STS_ENUM",   
    "DBR_STS_BYTE",   
    "DBR_STS_INT",    
    "DBR_STS_DOUBLE", 
    "DBR_TIME_STRING",
    "DBR_TIME_SHORT", 
    "DBR_TIME_FLOAT", 
    "DBR_TIME_ENUM",  
    "DBR_TIME_BYTE",  
    "DBR_TIME_INT",   
    "DBR_TIME_DOUBLE",
    "NOT_IMPLEMENTED",
    "DBR_GR_SHORT",   
    "DBR_GR_FLOAT",   
    "DBR_LABELS_ENUM",
    "DBR_GR_BYTE",    
    "DBR_GR_INT", 
    "DBR_GR_DOUBLE",
    "NOT_IMPLEMENTED",
    "DBR_CTRL_SHORT", 
    "DBR_CTRL_FLOAT",
    "DBR_LABELS_ENUM",
    "DBR_CTRL_BYTE", 
    "DBR_CTRL_INT",   
    "DBR_CTRL_DOUBLE",
    "DBR_PUT_ACKT",
    "DBR_PUT_ACKS",
    "DBR_STSACK_STRING"
    };


    static final public int CS_FIRST           = 0;
  static final public int CS_NEVER_CONN      = 0;
  static final public int CS_PREV_CONN       = 1;
  static final public int CS_CONN            = 2;
  static final public int CS_CLOSED          = 3;
  static final public int CS_LAST            = 3;

  static final public String[] CS_STRING= {
    "CS_NEVER_CONN",
    "CS_PREV_CONN",
    "CS_CONN",
    "CS_CLOSED" 
    };

  static final public int CA_OP_FIRST        = 0;
  static final public int CA_OP_GET          = 0;
  static final public int CA_OP_PUT          = 1;
  static final public int CA_OP_SEARCH       = 2;
  static final public int CA_OP_ADD_MONITOR  = 3;
  static final public int CA_OP_CLEAR_MONITOR= 4;
  static final public int CA_OP_OTHER        = 5;
  static final public int CA_OP_CONN_UP      = 6;
  static final public int CA_OP_CONN_DOWN    = 7;
  static final public int CA_OP_LAST         = 7;

  static final public String[] CA_OP_STRING= {
    "CA_OP_GET",
    "CA_OP_PUT",
    "CA_OP_SEARCH",
    "CA_OP_ADD_MONITOR",
    "CA_OP_CLEAR_MONITOR",
    "CA_OP_OTHER",
    "CA_OP_CONN_UP",
    "CA_OP_CONN_DOWN" 
    };



  static final public int CA_K_INFO       = 3;   /* successful */
  static final public int CA_K_ERROR      = 2;   /* failed- continue */
  static final public int CA_K_SUCCESS    = 1;   /* successful */
  static final public int CA_K_WARNING    = 0;   /* unsuccessful */
  static final public int CA_K_SEVERE     = 4;   /* failed- quit */
  static final public int CA_K_FATAL      = CA_K_ERROR | CA_K_SEVERE;





  static final public int CA_M_MSG_NO     = 0x0000FFF8;
  static final public int CA_M_SEVERITY   = 0x00000007;
  static final public int CA_M_LEVEL      = 0x00000003;
  static final public int CA_M_SUCCESS    = 0x00000001;
  static final public int CA_M_ERROR      = 0x00000002;
  static final public int CA_M_SEVERE     = 0x00000004;

//#define CA_S_MSG_NO     0x0D
//#define CA_S_SEVERITY   0x03

  static final public int CA_V_MSG_NO     = 0x03;
  static final public int CA_V_SEVERITY   = 0x00;
  static final public int CA_V_SUCCESS    = 0x00;



/*
 * In the lines below "defunct" indicates that current release 
 * servers and client library will not return this error code, but
 * servers on earlier releases that communicate with current clients 
 * might still generate exceptions with these error constants
 */


  static final public int ECA_FIRST= 0;
  static final public int ECA_NORMAL          = ((CA_K_SUCCESS<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 0<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_MAXIOC          = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 1<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_UKNHOST         = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 2<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_UKNSERV         = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 3<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_SOCK            = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 4<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_CONN            = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 5<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_ALLOCMEM        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 6<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_UKNCHAN         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 7<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_UKNFIELD        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 8<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_TOLARGE         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | (( 9<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_TIMEOUT         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((10<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOSUPPORT       = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((11<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_STRTOBIG        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((12<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_DISCONNCHID     = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((13<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_BADTYPE         = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((14<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_CHIDNOTFND      = ((CA_K_INFO   <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((15<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_CHIDRETRY       = ((CA_K_INFO   <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((16<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_INTERNAL        = ((CA_K_FATAL  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((17<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_DBLCLFAIL       = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((18<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_GETFAIL         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((19<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_PUTFAIL         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((20<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_ADDFAIL         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((21<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_BADCOUNT        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((22<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BADSTR          = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((23<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_DISCONN         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((24<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_DBLCHNL         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((25<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_EVDISALLOW      = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((26<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BUILDGET        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((27<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NEEDSFP         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((28<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_OVEVFAIL        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((29<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_BADMONID        = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((30<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NEWADDR         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((31<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NEWCONN         = ((CA_K_INFO   <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((32<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NOCACTX         = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((33<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_DEFUNCT         = ((CA_K_FATAL  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((34<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_EMPTYSTR        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((35<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NOREPEATER      = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((36<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NOCHANMSG       = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((37<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_DLCKREST        = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((38<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_SERVBEHIND      = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((39<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_NOCAST          = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((40<<CA_V_MSG_NO) & CA_M_MSG_NO) ; /* defunct */
  static final public int ECA_BADMASK         = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((41<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_IODONE          = ((CA_K_INFO   <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((42<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_IOINPROGRESS    = ((CA_K_INFO   <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((43<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BADSYNCGRP      = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((44<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_PUTCBINPROG     = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((45<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NORDACCESS      = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((46<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOWTACCESS      = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((47<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_ANACHRONISM     = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((48<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOSEARCHADDR    = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((49<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOCONVERT       = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((50<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BADCHID         = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((51<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BADFUNCPTR      = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((52<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_ISATTACHED      = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((53<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOTINSERVICE    = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((54<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_CHANDESTROY     = ((CA_K_WARNING<<CA_V_SEVERITY) & CA_M_SEVERITY) | ((55<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_BADPRIORITY     = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((56<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_NOTTHREADED     = ((CA_K_ERROR  <<CA_V_SEVERITY) & CA_M_SEVERITY) | ((57<<CA_V_MSG_NO) & CA_M_MSG_NO) ;
  static final public int ECA_LAST= 57;



  static final public String[] ECA_MESSAGE_STRING= {
    "Normal successful completion",
    "Maximum simultaneous IOC connections exceeded",
    "Unknown internet host",
    "Unknown internet service",
    "Unable to allocate a new socket",

    "Unable to connect to internet host or service",
    "Unable to allocate additional dynamic memory",
    "Unknown IO channel",
    "Record field specified inappropriate for channel specified",
    "The requested transfer is greater than available memory or EPICS_CA_MAX_ARRAY_BYTES",

    "User specified timeout on IO operation expired",
    "Sorry, that feature is planned but not supported at this time",
    "The supplied string is unusually large",
    "The request was ignored because the specified channel is disconnected",
    "The data type specifed is invalid",

    "Remote Channel not found",
    "Unable to locate all user specified channels",
    "Channel Access Internal Failure",
    "The requested local DB operation failed",
    "Could not perform a database value get for that channel",

    "Could not perform a database value put for that channel",
    "Could not perform a database event add for that channel",
    "Count requested inappropriate for that channel",
    "The supplied string has improper format",
    "Virtual circuit disconnect",

    "Identical process variable name on multiple servers",
    "The CA routine called is inappropriate for use within an event handler",
    "Database value get for that channel failed during channel search",
    "Unable to initialize without the vxWorks VX_FP_TASK task option set",
    "Event queue overflow has prevented first pass event after event add",

    "bad event subscription identifier",
    "Remote channel has new network address",
    "New or resumed network connection",
    "Specified task isnt a member of a CA context",
    "Attempt to use defunct CA feature failed",

    "The supplied string is empty",
    "Unable to spawn the CA repeater thread- auto reconnect will fail",
    "No channel id match for search reply- search reply ignored",
    "Reseting dead connection- will try to reconnect",
    "Server (IOC) has fallen behind or is not responding- still waiting",

    "No internet interface with broadcast available",
    "The event selection mask supplied is empty or inappropriate",
    "IO operations have completed",
    "IO operations are in progress",
    "Invalid synchronous group identifier",

    "Put callback timed out",
    "Read access denied",
    "Write access denied",
    "Sorry, that anachronistic feature of CA is no longer supported",
    "The search/beacon request address list was empty after initialization",

    "Data conversion between client's type and the server's type failed",
    "Invalid channel identifier",
    "Invalid function pointer",
    "Thread is already attached to a client context",
    "No support in service",

    "User destroyed channel",
    "Priority out of range",
    "Preemptive callback not enabled - additional threads may not join"
  };

}






