/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBR_PutAckT.java,v 1.1.1.1 2003/09/11 14:42:49 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */




package gov.aps.epics.jca.dbr;


public class DBR_PutAckT extends DBR implements SHORT {
  public DBR_PutAckT() {
    this(1);
  }
  public DBR_PutAckT(int count) {
    this(new short[count]);
  }
  public DBR_PutAckT(short[] value) {
    super(value);
    setType(DBR_PUT_ACKT);
  }
  public short[] getShortValue() { return (short[])getValue(); }
}


