/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBR_STSACK_String.java,v 1.1.1.1 2003/09/11 14:42:49 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */




package gov.aps.epics.jca.dbr;

import java.io.*;

public class DBR_STSACK_String extends DBR_STS_String implements ACK {
  protected int _ackt;
  protected int _acks;

  public DBR_STSACK_String() {
    this(1);
  }
  public DBR_STSACK_String(int count) {
    this(new String[count]);
  }
  public DBR_STSACK_String(String[] value) {
    super(value);
    setType(DBR_STSACK_STRING);
  }

  public int  getAckS()         { return _acks; }
  public void setAckS(int acks) { _acks=acks; }
  public int  getAckT()         { return _ackt;    }
  public void setAckT(int ackt) { _ackt=ackt; }

  public void printInfo(PrintStream out) {
    super.printInfo(out);
    out.println("ACKS     : "+ getAckS());
    out.println("ACKT     : "+ getAckT());
  }

}

