/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * JNIPutCallback.java,v 1.1.1.1 2003/09/11 14:42:49 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */


package gov.aps.epics.jca.jni;

import gov.aps.epics.jca.*;



public class JNIPutCallback {
  protected JNIChannel  _channel;
  protected PutListener _listener;

  public JNIPutCallback(JNIChannel channel, PutListener l) {
    _channel= channel;
    _listener= l;
  }

  public void fire(int type, int count, int dbrid, int status) {
    _listener.putCompleted(new PutEvent(_channel, type, count, status)); 
  }
}

