/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBR_DBString.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.dbr;
import java.lang.*;

/**
 * This class represents the Channel Access DBR_STRING type.
 *
 */
public class DBR_DBString implements DBR {
  public String m_value= null;

  public DBR_DBString() {
    this("");
  }

  public DBR_DBString(DBData val) {
    m_value= val.stringValue();
  }

  public DBR_DBString(String str) {
    m_value= str;
  }

  public int type() {
    return DBR.STRING;
  }
  
  public int count() {
    return 1;
  }

  public DBData dataAt(int at) {
    return new DBString(m_value);
  }
  
  public String valueAt(int at) {
    return m_value;
  }

  public String value() {
    return m_value;
  }
  
  public void update(gov.aps.epics.jca.dbr.DBR source) {
    String[] svalue= (String[])source.getValue();

    m_value= svalue[0];
  }

}
