/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBR_GR.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.dbr;
import java.lang.*;


/**
 * Interface for all DBR_GR_XXX objects.
 */
public interface DBR_GR extends DBR_STS {

  /**
   * Return the units string
   */
  public String units();
 
  /**
   * Return the upper display limit
   */
  public DBData upperDispLimit();

  /**
   * Return the lower display limit
   */
  public DBData lowerDispLimit();

  /**
   * Return the upper alarm limit
   */
  public DBData upperAlarmLimit();

  /**
   * Return the upper warning limit
   */
  public DBData upperWarningLimit();

  /**
   * Return the lower warning limit
   */
  public DBData lowerWarningLimit();

  /**
   * Return the lower alarm limit
   */
  public DBData lowerAlarmLimit();
}
