/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBR_TIME_DBString.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.dbr;

import jca.misc.*;
import java.lang.*;

/**
 * This class represents the Channel Access DBR_TIME_STRING type.
 *
 */
public class DBR_TIME_DBString extends DBR_STS_DBString implements DBR_TIME {
  protected TimeStamp m_stamp;

  public DBR_TIME_DBString() {
    super();
  }
  
  public int type() {
    return DBR.TIME_STRING;
  }

  public TimeStamp timeStamp() {
    return m_stamp;
  }
  
  public void update(gov.aps.epics.jca.dbr.DBR source) {
    super.update(source);
    gov.aps.epics.jca.dbr.TIME time= (gov.aps.epics.jca.dbr.TIME)source;
    m_stamp= new TimeStamp(time.getTimeStamp().secPastEpoch(), time.getTimeStamp().nsec());
  }

/*
  protected void setInfo(short status, short severity, int secPastEpoch, int nsec) {
    m_status= status;
    m_severity= severity;
    m_secPastEpoch= secPastEpoch;
    m_nsec= nsec;
  }
*/
}
