/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * DBString.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.dbr;
import java.lang.*;


public class DBString extends DBData {
  protected String m_value;
  
  public DBString(String val) {
    m_value= val;
  }
  
  public byte byteValue() {
    try {
      return Byte.valueOf(m_value).byteValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public short shortValue() {
    try {
      return Short.valueOf(m_value).shortValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public int intValue() {
    try {
      return Integer.valueOf(m_value).intValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public long longValue() {
    try {
      return Long.valueOf(m_value).longValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public float floatValue() {
    try {
      return Float.valueOf(m_value).floatValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public double doubleValue() {
    try {
      return Double.valueOf(m_value).doubleValue();
    } catch(NumberFormatException e) {
      return 0;
    }
  }
  
  public String stringValue() {
    return m_value;
  }
}