/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * ConnectionEvent.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.event;

import jca.*;
import jca.dbr.*;
import java.lang.*;

public class ConnectionEvent implements CaEvent {

  protected jca.PV                       m_pv;
  protected int                          m_op;
  protected jca.event.ConnectionListener m_listener;

  public ConnectionEvent(jca.PV pv, int op) {
    m_pv=pv;
    m_op= op;
  }
  
  public jca.PV pv() {
    return m_pv;
  }

  public int op() {
    return m_op;
  }

}
