/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * MonitorEvent.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.event;

import jca.*;
import jca.dbr.*;
import java.lang.*;

public class MonitorEvent implements CaEvent {
  protected int                       m_id=-1;
  protected jca.PV                    m_pv;
  protected jca.dbr.DBR               m_dbr;
  protected Object                    m_arg;
  protected int                       m_status=0;
//  protected jca.event.MonitorListener m_listener;

  public MonitorEvent(jca.PV pv, jca.dbr.DBR dbr, Object arg, int status/*, jca.event.MonitorListener l*/) {
    m_id= -1;
    m_pv=pv;
    m_dbr=dbr;
    m_arg= arg;
    m_status= status;
//    m_listener= l;
  }

  public int id() {
    return m_id;
  }
  
  public jca.PV pv() {
    return m_pv;
  }

  public int type() {
    return m_dbr.type();
  }

  public int count() {
    return m_dbr.count();
  }

  public jca.dbr.DBR dbr() {
    return m_dbr;
  }

  public Object arg() {
    return m_arg;
  }

  public int status() {
    return m_status;
  }

/*
  public void fire() {
    m_listener.monitorChanged(this);
  }

  public void update(int status) {
    m_status= status;
  }
*/  
}
