/**********************************************************************
 * 
 *      Original Author: Eric Boucher
 *      Date:            05/05/2003
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contract
 *      W-31-109-ENG-38 at Argonne National Laboratory.
 *
 *      Beamline Controls & Data Acquisition Group
 *      Experimental Facilities Division
 *      Advanced Photon Source
 *      Argonne National Laboratory
 *
 *
 * TestGUI.java,v 1.1.1.1 2003/09/11 14:42:50 boucher Exp
 *
 * Modification Log:
 * 01. 05/07/2003  erb  initial development
 *
 */

package jca.test;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import jca.*;
import jca.dbr.*;
import jca.event.*;

/**
 * @deprecated
 */
public class TestGUI extends JFrame 
{
    PV m_pv=null;

    void changePV()
    {
      JValue.setText("");
      JStatus.setText("");
      JSeverity.setText("");
      JUnits.setText("");
      JUpperDisp.setText("");
      JLowerDisp.setText("");
      JUpperAlarm.setText("");
      JUpperWarning.setText("");
      JLowerWarning.setText("");
      JLowerAlarm.setText("");
      JUpperControl.setText("");
      JLowerControl.setText("");

      if(JPVName.getText().equals("")) return;
      try {
        m_pv= new PV(JPVName.getText());
        Ca.pendIO(1.0);
        
        DBR_CTRL_DBDouble val= new DBR_CTRL_DBDouble();
        m_pv.get(val);
        Ca.pendIO(1.0);

        JValue.setText(val.dataAt(0).stringValue());
        JStatus.setText(""+val.status());
        JSeverity.setText(""+val.severity());
        JUnits.setText(val.units());
        JUpperDisp.setText(val.upperDispLimit().stringValue());
        JLowerDisp.setText(val.lowerDispLimit().stringValue());
        JUpperAlarm.setText(val.upperAlarmLimit().stringValue());
        JUpperWarning.setText(val.upperWarningLimit().stringValue());
        JLowerWarning.setText(val.lowerWarningLimit().stringValue());
        JLowerAlarm.setText(val.lowerAlarmLimit().stringValue());
        JUpperControl.setText(val.upperCtrlLimit().stringValue());
        JLowerControl.setText(val.lowerCtrlLimit().stringValue());
      } catch (CaException e) {
        JValue.setText(e.toString());
        e.printStackTrace();
      } catch(Throwable t) {
        t.printStackTrace();
      } finally {
        m_pv.clear();
        m_pv= null;
      }
    }

	public TestGUI()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("JCA Test");
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new GridBagLayout());
		setSize(493,371);
		setVisible(false);
		JPanel3.setBorder(titledBorder2);
		JPanel3.setLayout(new GridBagLayout());
		getContentPane().add(JPanel3,new GridBagConstraints(0,0,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(5,5,5,5),0,0));
		JPanel3.setBounds(5,5,483,47);
		JLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
		JLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel1.setText("PV");
		JPanel3.add(JLabel1, new GridBagConstraints(0,0,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(5,5,5,5),0,0));
		JLabel1.setBounds(11,16,16,15);
		JPanel3.add(JPVName, new GridBagConstraints(1,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(5,5,5,5),0,0));
		JPVName.setBounds(37,14,350,19);
		JGetInfo.setText("GetInfo");
		JGetInfo.setActionCommand("GetInfo");
		JPanel3.add(JGetInfo, new GridBagConstraints(2,0,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(5,5,5,5),0,0));
		JGetInfo.setBounds(397,11,75,25);
		JPanel1.setBorder(titledBorder1);
		JPanel1.setLayout(new GridBagLayout());
		getContentPane().add(JPanel1,new GridBagConstraints(0,1,1,1,1.0,1.0,java.awt.GridBagConstraints.NORTH,java.awt.GridBagConstraints.HORIZONTAL,new Insets(5,5,5,5),0,0));
		JPanel1.setBounds(5,62,483,276);
		JLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel2.setText("Value");
		JPanel1.add(JLabel2, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),5,0));
		JLabel2.setBounds(11,22,114,15);
		JValue.setEditable(false);
		JPanel1.add(JValue, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JValue.setBounds(130,20,347,19);
		JLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel3.setText("Status");
		JPanel1.add(JLabel3, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel3.setBounds(11,42,114,15);
		JStatus.setEditable(false);
		JPanel1.add(JStatus, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JStatus.setBounds(130,41,347,19);
		JLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel4.setText("Severity");
		JPanel1.add(JLabel4, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel4.setBounds(11,63,114,15);
		JSeverity.setEditable(false);
		JPanel1.add(JSeverity, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JSeverity.setBounds(130,62,347,19);
		JLabel5.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel5.setText("Units");
		JPanel1.add(JLabel5, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel5.setBounds(11,84,114,15);
		JUnits.setEditable(false);
		JPanel1.add(JUnits, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JUnits.setBounds(130,83,347,19);
		JLabel6.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel6.setText("Upper Display limit");
		JPanel1.add(JLabel6, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel6.setBounds(11,105,114,15);
		JUpperDisp.setEditable(false);
		JPanel1.add(JUpperDisp, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JUpperDisp.setBounds(130,104,347,19);
		JLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel7.setText("Lower Display limit");
		JPanel1.add(JLabel7, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel7.setBounds(11,126,114,15);
		JLowerDisp.setEditable(false);
		JPanel1.add(JLowerDisp, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JLowerDisp.setBounds(130,125,347,19);
		JLabel8.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel8.setText("Upper Alarm limit");
		JPanel1.add(JLabel8, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel8.setBounds(11,147,114,15);
		JUpperAlarm.setEditable(false);
		JPanel1.add(JUpperAlarm, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JUpperAlarm.setBounds(130,146,347,19);
		JLabel9.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel9.setText("Upper Warning limit");
		JPanel1.add(JLabel9, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel9.setBounds(11,168,114,15);
		JUpperWarning.setEditable(false);
		JPanel1.add(JUpperWarning, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JUpperWarning.setBounds(130,167,347,19);
		JLabel10.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel10.setText("Lower Warning limit");
		JPanel1.add(JLabel10, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel10.setBounds(11,189,114,15);
		JLowerWarning.setEditable(false);
		JPanel1.add(JLowerWarning, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JLowerWarning.setBounds(130,188,347,19);
		JLabel11.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel11.setText("Lower Alarm limit");
		JPanel1.add(JLabel11, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel11.setBounds(11,210,114,15);
		JLowerAlarm.setEditable(false);
		JPanel1.add(JLowerAlarm, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JLowerAlarm.setBounds(130,209,347,19);
		JLabel12.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel12.setText("Upper Control limit");
		JPanel1.add(JLabel12, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel12.setBounds(11,231,114,15);
		JUpperControl.setEditable(false);
		JPanel1.add(JUpperControl, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JUpperControl.setBounds(130,230,347,19);
		JLabel13.setHorizontalAlignment(SwingConstants.RIGHT);
		JLabel13.setText("Lower Control limit");
		JPanel1.add(JLabel13, new GridBagConstraints(0,-1,1,1,0.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,5,0,5),0,0));
		JLabel13.setBounds(11,252,114,15);
		JLowerControl.setEditable(false);
		JPanel1.add(JLowerControl, new GridBagConstraints(1,-1,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(2,0,0,0),0,0));
		JLowerControl.setBounds(130,251,347,19);
		titledBorder1.setTitle("PV Info");
		//$$ titledBorder1.move(12,396);
		//$$ titledBorder2.move(48,396);
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		JGetInfo.addActionListener(lSymAction);
		JPVName.addActionListener(lSymAction);
		//}}

    Ca.init();
	}

    /**
     * Creates a new instance of JFrame1 with the given title.
     * @param sTitle the title for the new frame.
     */
	public TestGUI(String sTitle)
	{
		this();
		setTitle(sTitle);
	}
	
	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new JFrame1 and makes it visible.
	 */
	static public void main(String args[])
	{
		try {
		    // Add the following code if you want the Look and Feel
		    // to be set to the Look and Feel of the native system.
		    /*
		    try {
		        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    } 
		    catch (Exception e) { 
		    }
		    */

			//Create a new instance of our application's frame, and make it visible.
			(new TestGUI()).setVisible(true);
		} 
		catch (Throwable t) {
			t.printStackTrace();
			//Ensure the application exits with an error condition.
			System.exit(1);
		}
	}

    /**
     * Notifies this component that it has been added to a container
     * This method should be called by <code>Container.add</code>, and 
     * not by user code directly.
     * Overridden here to adjust the size of the frame if needed.
     */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension size = getSize();
		
		super.addNotify();
		
		if (frameSizeAdjusted)
			return;
		frameSizeAdjusted = true;
		
		// Adjust size of frame according to the insets and menu bar
		JMenuBar menuBar = getRootPane().getJMenuBar();
		int menuBarHeight = 0;
		if (menuBar != null)
		    menuBarHeight = menuBar.getPreferredSize().height;
		Insets insets = getInsets();
		setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height + menuBarHeight);
	}

	// Used by addNotify
	boolean frameSizeAdjusted = false;

	//{{DECLARE_CONTROLS
	JPanel JPanel3 = new JPanel();
	JLabel JLabel1 = new JLabel();
	JTextField JPVName = new JTextField();
	JButton JGetInfo = new JButton();
	JPanel JPanel1 = new JPanel();
	JLabel JLabel2 = new JLabel();
	JTextField JValue = new JTextField();
	JLabel JLabel3 = new JLabel();
	JTextField JStatus = new JTextField();
	JLabel JLabel4 = new JLabel();
	JTextField JSeverity = new JTextField();
	JLabel JLabel5 = new JLabel();
	JTextField JUnits = new JTextField();
	JLabel JLabel6 = new JLabel();
	JTextField JUpperDisp = new JTextField();
	JLabel JLabel7 = new JLabel();
	JTextField JLowerDisp = new JTextField();
	JLabel JLabel8 = new JLabel();
	JTextField JUpperAlarm = new JTextField();
	JLabel JLabel9 = new JLabel();
	JTextField JUpperWarning = new JTextField();
	JLabel JLabel10 = new JLabel();
	JTextField JLowerWarning = new JTextField();
	JLabel JLabel11 = new JLabel();
	JTextField JLowerAlarm = new JTextField();
	JLabel JLabel12 = new JLabel();
	JTextField JUpperControl = new JTextField();
	JLabel JLabel13 = new JLabel();
	JTextField JLowerControl = new JTextField();
	TitledBorder titledBorder1 = new TitledBorder("");
	TitledBorder titledBorder2 = new TitledBorder("");
	//}}

	//{{DECLARE_MENUS
	//}}

	void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this, 
	    	                                          "Do you really want to exit?", 
	    	                                          "JFC Application - Exit" , 
	    	                                          JOptionPane.YES_NO_OPTION, 
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
          Ca.exit();
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {
		}
	}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == TestGUI.this)
				TestGUI_windowClosing(event);
		}
	}

	void TestGUI_windowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		TestGUI_windowClosing_Interaction1(event);
	}

	void TestGUI_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object.equals(JGetInfo)) {
				JGetInfo_actionPerformed(event);
      } else if (object.equals(JPVName)) {
				JPVName_actionPerformed(event);
      }
			
		}
	}

	void JGetInfo_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
			 
		JGetInfo_actionPerformed_Interaction1(event);
	}

	void JGetInfo_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.changePV();
		} catch (Exception e) {
		}
	}

	void JPVName_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		JPVName_actionPerformed_Interaction1(event);
	}

	void JPVName_actionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.changePV();
		} catch (Exception e) {
		}
	}
}
